<?php

function SessionStart() {
   session_cache_limiter('nocache');
   session_cache_expire(5);
   session_start();
   }

function SessionEnd() {
   session_destroy();
   }

function SessionPop($descriptor) {
   $val = null;
   if (isset($_SESSION[$descriptor])) {
      $val = $_SESSION[$descriptor];
      unset($_SESSION[$descriptor]);
      }
   return $val;
   }

function SessionPush($descriptor, $value) {
   $_SESSION[$descriptor] = $value;
   }

function SessionRead($descriptor) {
   $val = null;
   if (isset($_SESSION[$descriptor])) {
      $val = $_SESSION[$descriptor];
      }
   return $val;
   }


function SessionSaltRead($descriptor) {
   $val = null;
   if (isset($_SESSION[$descriptor])) {
      $val = substr($_SESSION[$descriptor],12);
      }
   return $val;
   }

function SessionSaltPop($descriptor) {
   $val = null;
   if (isset($_SESSION[$descriptor])) {
      $val = SessionSaltRead($descriptor);
      unset($_SESSION[$descriptor]);
      }
   return $val;
   }

function SessionSaltPush($descriptor, $value) {
   $_SESSION[$descriptor] = 'SAL71SS1LV3R' . $value;
   }

function SessionCheck($attribute, $page) {
   if (!isset($_SESSION[$attribute])) {
      SessionPush('login_error','Session Time Out');
      header( 'Location: '. $page );
      exit;
      }
   if (isset($_SESSION['HTTP_USER_AGENT'])) {
      $salted_agent = $_SERVER['HTTP_USER_AGENT'];
      $salted_agent .= 'SAL71SG0LD';
      $fingerprint = md5($salted_agent);
      if ($_SESSION['HTTP_USER_AGENT'] != $fingerprint) {
         SessionPop('HTTP_USER_AGENT');
         SessionPush('login_error','Session Time Out');
         header( 'Location: '. $page );
         exit;
         }
      }
   else {
      $salted_agent = $_SERVER['HTTP_USER_AGENT'];
      $salted_agent .= 'SAL71SG0LD';
      $fingerprint = md5($salted_agent);
      $_SESSION['HTTP_USER_AGENT'] = $fingerprint;
      }
   }

?>
